/*-------------------- Point-to-Point Routines --------------
 File : native.c
   Date : 2/16/95
------------------------------------------------------------*/
#include "scarab.h"

int Expert_System()
{
  return(1);
} 


/*---Generic Asy. Send ---*/

long GenAsySend(sendbuf,count,destination,Tag)
   void *sendbuf;   /* address of the send buffer */
   int  count;    /* number of bytes */
   int  destination;   /* destination address */
   int  Tag;   /* message tag */
{
#if MACHINE==CM_5
  /* Use CMMD asyn. send */
  return(CMMD_send_async(destination,Tag,sendbuf,count,NULL,NULL));
#elif  MACHINE==Paragon
  /* Use nx asyn send */
  return(isend(Tag,sendbuf,count,destination,ANY_TAG));
#elif   MACHINE==nCube
   int flags =0;
      if ( nwrite(sendbuf,count,destination,Tag,&flags)== -1 ) 
            printf(" Error in Sending.....\n");
#else
  Error = -1;
#endif
  
  return(Error);
}

/*---Generic Syn. Send ---*/
int GenSynSend(sendbuf,count,destination,Tag)
   void *sendbuf;   /* address of the send buffer */
   int  count;    /* number of bytes */
   int  destination;   /* destination address */
   int  Tag;   /* message tag */
{
 #if MACHINE==CM_5
   /* Use CMMD syn. send */
    return(CMMD_send_block(destination,Tag,sendbuf,count));
 #elif  MACHINE==Paragon
   /* Use nx syn send */
    csend(Tag,sendbuf,count,destination,ANY_TAG);
    return(1);
#elif MACHINE==nCube
  int flags =0;
      if ( nwrite(sendbuf,count,destination,Tag,&flags)== -1 ) 
            printf(" Error in Sending.....\n");
 #else
    Error = -1;
 #endif

 return(Error);
}

/*---Generic Asyn. Receive ---*/
long GenAsyReceive(recvbuf,count,source,Tag)
   void *recvbuf;   /* address of the receive buffer */
   int  count;    /* number of bytes */
   int  source;   /* source address */
   int  Tag;   /* message tag */
{
 #if MACHINE==CM_5
   /* Use CMMD Asyn. receive */
   return(CMMD_receive_async(source,Tag,recvbuf,count,NULL,NULL));
 #elif  MACHINE==Paragon
   /* Use nx Asyn. receive */
   return(irecv(Tag,(char *)recvbuf,count));
 #else
    Error = -1;
 #endif

 return(Error);
}


/*---Generic syn. Receive ---*/
int GenSynReceive(recvbuf,count,source,Tag)
   void *recvbuf;   /* address of the receive buffer */
   int  count;    /* number of bytes */
   int  source;   /* source address */
   int  Tag;   /* message tag */
{
 #if MACHINE==CM_5
   /* Use CMMD syn. receive */
   return(CMMD_receive_block(source,Tag,recvbuf,count));
 #elif  MACHINE==Paragon
   /* Use nx syn. receive */
   crecv(Tag,(char *)recvbuf,count);
   return(1);  /* No error */
#elif MACHINE==nCube
  int flags=0;
   if ( nread(recvbuf,count,&source,&Tag,&flags)==-1)
    printf(" error in receiving....\n");
 #else
    Error = -1;
 #endif

 return(Error);
}


/*---- Generic Handler for Asyn. send/receive */
void   GenAsyHanlde(Status)
  long Status;
{ int id;

  #if MACHINE==CM_5
     id = Status;
     CMMD_msg_wait(id);
     CMMD_free_mcb(id);
  #elif  MACHINE==Paragon
    msgwait(Status);
  #endif
}


/*====================      Active   Messages  Routines   ================*/
      /*---   RPorts  Routines   ------*/

int Allocate_rport(rport)
int rport;
{
  #if MACHINE==CM_5
    return(CMAML_allocate_this_rport(rport));
  #else
    return(-1);
  #endif
}

int Free_rport(rport)
int rport;
{
  #if MACHINE==CM_5
    return(CMAML_free_rport(rport));
  #else
    return(-1);
  #endif
}

int Get_rport_byte_counter(rport)
int rport;
{
  #if MACHINE==CM_5
      return(CMAML_get_rport_byte_counter(rport));
  #else
      return(-1);
  #endif
}

void Set_rport_byte_counter(rport,no_bytes)
int rport,no_bytes;
{
  #if MACHINE==CM_5
      CMAML_set_rport_total_nbytes(rport,no_bytes);
      CMAML_set_rport_byte_counter(rport,no_bytes);
  #endif
}

void Set_rport_handler(rport,handler_ptr)
int rport;
void *handler_ptr;
{
  #if MACHINE==CM_5
    CMAML_set_rport_handler_arg2(rport,NULL);
    CMAML_set_rport_handler(rport,handler_ptr);
  #endif
}

void Set_rport_address(rport, addr)
int rport;
void *addr;
{
  #if MACHINE==CM_5
     CMAML_set_rport_addr(rport,addr);
  #endif
}

      /*----  Polling Routines  ------*/
void Gen_Poll(void)
{
  #if MACHINE==CM_5
    CMAML_poll();
  #endif
}

void Gen_Poll_until(variable,value)
int *variable;
int value;
{
  #if MACHINE==CM_5
      CMAML_poll_while_lt(variable,value);
  #endif
}

     /*----  Sending  Active  Message  -----*/

int Gen_request(dest,handler,arg1,arg2,arg3,arg4)
 int dest;
 void (*handler)();
 int arg1,arg2,arg3,arg4;
{
  #if  MACHINE==CM_5
    CMAML_request(dest,handler,arg1,arg2,arg3,arg4);
  #endif
}
int Gen_reply(dest,handler,arg1,arg2,arg3,arg4)
 int dest;
 void (*handler)();
 int arg1,arg2,arg3,arg4;
{
  #if  MACHINE==CM_5
    CMAML_reply(dest,handler,arg1,arg2,arg3,arg4);
  #endif
}


    /*----   Sending Block of Data   -----*/
int Gen_send_rport(dest,rport,offset,sendbuf,recvbuf,count,
                   datatypesize)
  int dest;         /* destination */
  int rport;        /* rport number */
  int offset;       /* dest. buffer offset, in no. of elements*/
  void *sendbuf;       /* source address */
  void *recvbuf;     
  int  count;          /* Number of elements */
  int datatypesize;        /* element size , in bytes */
{
 int ralign;
 char *ptrrecv,*ptrsend;
 char *temp;
 int salign; 
 #if MACHINE == CM_5
   ptrrecv = recvbuf;
   ptrsend = sendbuf;
   ralign = (long) (ptrrecv+(offset*datatypesize))%8;
   salign = (long) ptrsend%8;
   if ( salign != 0 ) {
 /*  printf("%d align ......%x    %x %d \n",salign,sendbuf,ptrsend,count*datatypesize); */
/*   GenBarrier(); */
   }
/*   printf("%d align ......%x    %x %d \n",salign,sendbuf,ptrsend,count*datatypesize); */
   CMAML_scopy(dest,rport,ralign,offset*datatypesize,sendbuf,
       count*datatypesize,NULL,NULL);
 #endif

}
